apiVersion: apps/v1
kind: Deployment
metadata:
  annotations:
    deployment.kubernetes.io/revision: "1"
  generation: 2
  labels:
    crunchy-pgha-scope: some-name
    deployment-name: some-name
    name: some-name
    pg-cluster: some-name
    pgo-pg-database: "true"
    pgo-version: 1.2.0
    pgouser: admin
    service-name: some-name
    vendor: crunchydata
  name: some-name
spec:
  progressDeadlineSeconds: 600
  replicas: 1
  revisionHistoryLimit: 10
  selector:
    matchLabels:
      deployment-name: some-name
      pg-cluster: some-name
      pgo-pg-database: "true"
      vendor: crunchydata
  strategy:
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 1
    type: RollingUpdate
  template:
    metadata:
      annotations:
        keep-backups: "false"
        keep-data: "false"
      labels:
        crunchy-pgha-scope: some-name
        deployment-name: some-name
        name: some-name
        pg-cluster: some-name
        pg-pod-anti-affinity: preferred
        pgo-pg-database: "true"
        pgo-version: 1.2.0
        pgouser: admin
        vendor: crunchydata
    spec:
      affinity:
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - podAffinityTerm:
                labelSelector:
                  matchExpressions:
                    - key: vendor
                      operator: In
                      values:
                        - crunchydata
                    - key: pg-pod-anti-affinity
                      operator: Exists
                    - key: pg-cluster
                      operator: In
                      values:
                        - some-name
                topologyKey: kubernetes.io/hostname
              weight: 1
      containers:
        - env:
            - name: MODE
              value: postgres
            - name: PGHA_PG_PORT
              value: "5432"
            - name: PGHA_USER
              value: postgres
            - name: PGHA_INIT
              valueFrom:
                configMapKeyRef:
                  key: init
                  name: some-name-pgha-config
            - name: PATRONI_POSTGRESQL_DATA_DIR
              value: /pgdata/some-name
            - name: PGBACKREST_STANZA
              value: db
            - name: PGBACKREST_REPO1_HOST
              value: some-name-backrest-shared-repo
            - name: BACKREST_SKIP_CREATE_STANZA
              value: "true"
            - name: PGHA_PGBACKREST
              value: "true"
            - name: PGBACKREST_REPO1_PATH
              value: /backrestrepo/some-name-backrest-shared-repo
            - name: PGBACKREST_DB_PATH
              value: /pgdata/some-name
            - name: ENABLE_SSHD
              value: "true"
            - name: PGBACKREST_LOG_PATH
              value: /tmp
            - name: PGBACKREST_PG1_SOCKET_PATH
              value: /tmp
            - name: PGBACKREST_PG1_PORT
              value: "5432"
            - name: PGBACKREST_REPO1_TYPE
              value: posix
            - name: PGHA_PGBACKREST_LOCAL_S3_STORAGE
              value: "false"
            - name: PGHA_PGBACKREST_LOCAL_GCS_STORAGE
              value: "false"
            - name: PGHA_DATABASE
              value: some-name
            - name: PGHA_REPLICA_REINIT_ON_START_FAIL
              value: "true"
            - name: PGHA_SYNC_REPLICATION
              value: "false"
            - name: PGHA_TLS_ENABLED
              value: "false"
            - name: PGHA_TLS_ONLY
              value: "false"
            - name: PGHA_PASSWORD_TYPE
            - name: PGHA_STANDBY
              value: "false"
            - name: PATRONI_KUBERNETES_NAMESPACE
              valueFrom:
                fieldRef:
                  apiVersion: v1
                  fieldPath: metadata.namespace
            - name: PATRONI_KUBERNETES_SCOPE_LABEL
              value: crunchy-pgha-scope
            - name: PATRONI_SCOPE
              valueFrom:
                fieldRef:
                  apiVersion: v1
                  fieldPath: metadata.labels['crunchy-pgha-scope']
            - name: PATRONI_KUBERNETES_LABELS
              value: '{vendor: "crunchydata"}'
            - name: PATRONI_LOG_LEVEL
              value: INFO
            - name: PGHOST
              value: /tmp
            - name: LD_PRELOAD
              value: /usr/lib64/libnss_wrapper.so
            - name: NSS_WRAPPER_PASSWD
              value: /tmp/nss_wrapper/postgres/passwd
            - name: NSS_WRAPPER_GROUP
              value: /tmp/nss_wrapper/postgres/group
          imagePullPolicy: Always
          livenessProbe:
            exec:
              command:
                - /opt/crunchy/bin/postgres-ha/health/pgha-liveness.sh
            failureThreshold: 3
            initialDelaySeconds: 30
            periodSeconds: 15
            successThreshold: 1
            timeoutSeconds: 10
          name: database
          ports:
            - containerPort: 5432
              name: postgres
              protocol: TCP
            - containerPort: 8009
              name: patroni
              protocol: TCP
          readinessProbe:
            exec:
              command:
                - /opt/crunchy/bin/postgres-ha/health/pgha-readiness.sh
            failureThreshold: 3
            initialDelaySeconds: 15
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
          resources:
            requests:
              memory: 128Mi
          securityContext:
            allowPrivilegeEscalation: false
            privileged: false
            readOnlyRootFilesystem: true
          terminationMessagePath: /dev/termination-log
          terminationMessagePolicy: File
          volumeMounts:
            - mountPath: /pgdata
              name: pgdata
            - mountPath: /pgconf/pguser
              name: user-volume
            - mountPath: /pgconf/pgreplicator
              name: primary-volume
            - mountPath: /pgconf/pgsuper
              name: root-volume
            - mountPath: /sshd
              name: sshd
              readOnly: true
            - mountPath: /etc/ssh
              name: ssh-config
              readOnly: true
            - mountPath: /pgconf
              name: pgconf-volume
            - mountPath: /dev/shm
              name: dshm
            - mountPath: /etc/pgbackrest/conf.d
              name: pgbackrest-config
            - mountPath: /etc/podinfo
              name: podinfo
            - mountPath: /tmp
              name: tmp
        - env:
            - name: BADGER_TARGET
              value: some-name
            - name: PGBADGER_SERVICE_PORT
              value: "10000"
          imagePullPolicy: Always
          name: pgbadger
          ports:
            - containerPort: 10000
              name: pgbadger
              protocol: TCP
          readinessProbe:
            failureThreshold: 3
            initialDelaySeconds: 20
            periodSeconds: 10
            successThreshold: 1
            tcpSocket:
              port: 10000
            timeoutSeconds: 1
          resources:
            limits:
              cpu: 500m
              memory: 64Mi
          securityContext:
            allowPrivilegeEscalation: false
            privileged: false
            readOnlyRootFilesystem: true
          terminationMessagePath: /dev/termination-log
          terminationMessagePolicy: File
          volumeMounts:
            - mountPath: /tmp
              name: tmp
            - mountPath: /pgdata
              name: pgdata
              readOnly: true
            - mountPath: /report
              name: report
        - env:
            - name: PMM_USER
              value: admin
            - name: PMM_SERVER
              value: monitoring-service
            - name: CLIENT_PORT_LISTEN
              value: "7777"
            - name: CLIENT_PORT_MIN
              value: "30100"
            - name: CLIENT_PORT_MAX
              value: "30105"
            - name: POD_NAME
              valueFrom:
                fieldRef:
                  apiVersion: v1
                  fieldPath: metadata.name
            - name: POD_NAMESPASE
              valueFrom:
                fieldRef:
                  apiVersion: v1
                  fieldPath: metadata.namespace
            - name: PMM_AGENT_SERVER_ADDRESS
              value: monitoring-service
            - name: PMM_AGENT_SERVER_USERNAME
              value: admin
            - name: PMM_AGENT_SERVER_PASSWORD
              valueFrom:
                secretKeyRef:
                  key: password
                  name: some-name-pmm-secret
            - name: PMM_AGENT_LISTEN_PORT
              value: "7777"
            - name: PMM_AGENT_PORTS_MIN
              value: "30100"
            - name: PMM_AGENT_PORTS_MAX
              value: "30105"
            - name: PMM_AGENT_CONFIG_FILE
              value: /usr/local/percona/pmm2/config/pmm-agent.yaml
            - name: PMM_AGENT_SERVER_INSECURE_TLS
              value: "1"
            - name: PMM_AGENT_LISTEN_ADDRESS
              value: 0.0.0.0
            - name: PMM_AGENT_SETUP_NODE_NAME
              value: some-name
            - name: PMM_AGENT_SETUP_METRICS_MODE
              value: push
            - name: PMM_AGENT_SETUP
              value: "1"
            - name: PMM_AGENT_SETUP_FORCE
              value: "1"
            - name: PMM_AGENT_SETUP_NODE_TYPE
              value: container
            - name: DB_TYPE
              value: postgresql
            - name: PMM_AGENT_SIDECAR
              value: "true"
            - name: PMM_AGENT_SIDECAR_SLEEP
              value: "5"
            - name: DB_PASS
              valueFrom:
                secretKeyRef:
                  key: password
                  name: some-name-postgres-secret
            - name: PMM_AGENT_PRERUN_SCRIPT
              value: pmm-admin status --wait=10s; pmm-admin add postgresql --tls-skip-verify --skip-connection-check --metrics-mode=push --username=postgres --password=$(DB_PASS) --service-name=$(PMM_AGENT_SETUP_NODE_NAME) --host=$(POD_NAME) --port=5432 --query-source=pgstatmonitor; pmm-admin annotate --service-name=$(PMM_AGENT_SETUP_NODE_NAME) 'Service restarted'
          imagePullPolicy: Always
          lifecycle:
            preStop:
              exec:
                command:
                  - bash
                  - -c
                  - pmm-admin inventory remove node --force $(pmm-admin status --json | python -c "import sys, json; print(json.load(sys.stdin)['pmm_agent_status']['node_id'])")
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /local/Status
              port: 7777
              scheme: HTTP
            initialDelaySeconds: 60
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 5
          name: pmm-client
          ports:
            - containerPort: 7777
              protocol: TCP
            - containerPort: 30100
              protocol: TCP
            - containerPort: 30101
              protocol: TCP
            - containerPort: 30102
              protocol: TCP
            - containerPort: 30103
              protocol: TCP
            - containerPort: 30104
              protocol: TCP
            - containerPort: 30105
              protocol: TCP
          resources:
            requests:
              cpu: 500m
              memory: 200M
          terminationMessagePath: /dev/termination-log
          terminationMessagePolicy: File
      dnsPolicy: ClusterFirst
      restartPolicy: Always
      schedulerName: default-scheduler
      securityContext:
        fsGroup: 26
        supplementalGroups:
          - 1001
      serviceAccount: pgo-pg
      serviceAccountName: pgo-pg
      terminationGracePeriodSeconds: 30
      volumes:
        - name: pgdata
          persistentVolumeClaim:
            claimName: some-name
        - name: user-volume
          secret:
            defaultMode: 420
            secretName: some-name-some-name-secret
        - name: primary-volume
          secret:
            defaultMode: 420
            secretName: some-name-primaryuser-secret
        - name: sshd
          secret:
            defaultMode: 420
            secretName: some-name-backrest-repo-config
        - name: ssh-config
          secret:
            defaultMode: 420
            items:
              - key: config
                path: ssh_config
            secretName: some-name-backrest-repo-config
        - name: root-volume
          secret:
            defaultMode: 420
            secretName: some-name-postgres-secret
        - emptyDir:
            medium: Memory
            sizeLimit: 64Mi
          name: report
        - emptyDir:
            medium: Memory
          name: dshm
        - emptyDir:
            medium: Memory
            sizeLimit: 16Mi
          name: tmp
        - name: pgbackrest-config
          projected:
            defaultMode: 420
            sources:
              - configMap:
                  name: some-name-config-backrest
                  optional: true
              - secret:
                  name: some-name-config-backrest
                  optional: true
        - name: pgconf-volume
          projected:
            defaultMode: 420
            sources:
              - configMap:
                  name: some-name-pgha-config
                  optional: true
        - downwardAPI:
            defaultMode: 420
            items:
              - path: cpu_limit
                resourceFieldRef:
                  containerName: database
                  divisor: 1m
                  resource: limits.cpu
              - path: cpu_request
                resourceFieldRef:
                  containerName: database
                  divisor: 1m
                  resource: requests.cpu
              - path: mem_limit
                resourceFieldRef:
                  containerName: database
                  divisor: "0"
                  resource: limits.memory
              - path: mem_request
                resourceFieldRef:
                  containerName: database
                  divisor: "0"
                  resource: requests.memory
              - fieldRef:
                  apiVersion: v1
                  fieldPath: metadata.labels
                path: labels
              - fieldRef:
                  apiVersion: v1
                  fieldPath: metadata.annotations
                path: annotations
          name: podinfo
